using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MySecondApp
{
	/// <summary>
	/// Summary description for Options.
	/// </summary>
	public class Options : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelColor;
		private System.Windows.Forms.Button buttonChange;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.ErrorProvider errorProvider1;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.Button buttonAbout;
        private WindowsControlLibrary1.UserControl1 userControl11;
        private IContainer components;

		public Options()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.labelColor = new System.Windows.Forms.Label();
            this.buttonChange = new System.Windows.Forms.Button();
            this.buttonOK = new System.Windows.Forms.Button();
            this.buttonCancel = new System.Windows.Forms.Button();
            this.errorProvider1 = new System.Windows.Forms.ErrorProvider(this.components);
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.buttonAbout = new System.Windows.Forms.Button();
            this.userControl11 = new WindowsControlLibrary1.UserControl1();
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider1)).BeginInit();
            this.SuspendLayout();
            // 
            // labelColor
            // 
            this.labelColor.Location = new System.Drawing.Point(40, 48);
            this.labelColor.Name = "labelColor";
            this.labelColor.Size = new System.Drawing.Size(80, 23);
            this.labelColor.TabIndex = 0;
            this.labelColor.Text = "Favorite Color";
            // 
            // buttonChange
            // 
            this.buttonChange.BackColor = System.Drawing.Color.SpringGreen;
            this.buttonChange.Location = new System.Drawing.Point(168, 48);
            this.buttonChange.Name = "buttonChange";
            this.buttonChange.Size = new System.Drawing.Size(75, 23);
            this.buttonChange.TabIndex = 1;
            this.buttonChange.Text = "Change";
            this.buttonChange.UseVisualStyleBackColor = false;
            this.buttonChange.Click += new System.EventHandler(this.buttonChange_Click);
            this.buttonChange.Validating += new System.ComponentModel.CancelEventHandler(this.buttonChange_Validating);
            // 
            // buttonOK
            // 
            this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.buttonOK.Location = new System.Drawing.Point(32, 176);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(75, 23);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            // 
            // buttonCancel
            // 
            this.buttonCancel.CausesValidation = false;
            this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.buttonCancel.Location = new System.Drawing.Point(112, 176);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 3;
            this.buttonCancel.Text = "Cancel";
            this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
            // 
            // errorProvider1
            // 
            this.errorProvider1.ContainerControl = this;
            // 
            // buttonAbout
            // 
            this.buttonAbout.CausesValidation = false;
            this.buttonAbout.Location = new System.Drawing.Point(192, 176);
            this.buttonAbout.Name = "buttonAbout";
            this.buttonAbout.Size = new System.Drawing.Size(75, 23);
            this.buttonAbout.TabIndex = 4;
            this.buttonAbout.Text = "About";
            this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
            // 
            // userControl11
            // 
            this.userControl11.Location = new System.Drawing.Point(64, 88);
            this.userControl11.Name = "userControl11";
            this.userControl11.Size = new System.Drawing.Size(128, 80);
            this.userControl11.TabIndex = 5;
            // 
            // Options
            // 
            this.AcceptButton = this.buttonOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.AutoValidate = System.Windows.Forms.AutoValidate.EnableAllowFocusChange;
            this.CancelButton = this.buttonCancel;
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.Add(this.userControl11);
            this.Controls.Add(this.buttonAbout);
            this.Controls.Add(this.buttonCancel);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.buttonChange);
            this.Controls.Add(this.labelColor);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Name = "Options";
            this.Text = "Options";
            this.Load += new System.EventHandler(this.Options_Load);
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private Color favoriteColor;

		private void buttonChange_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			byte greenness = buttonChange.BackColor.G;
			string err="";
			if(greenness < Color.LightGreen.G) 
			{
				err = "I'm sorry, we were going for more green...";
				e.Cancel = true;
			}
			errorProvider1.SetError(buttonChange, err);
		}

		private void buttonChange_Click(object sender, System.EventArgs e)
		{
			errorProvider1.SetError(buttonChange, "");
			if (colorDialog1.ShowDialog() == DialogResult.OK) 
			{
				buttonChange.BackColor = FavoriteColor;
			}
		}

		private void Options_Load(object sender, System.EventArgs e)
		{
			buttonChange.BackColor = FavoriteColor;
		}

		private void buttonAbout_Click(object sender, System.EventArgs e)
		{
			new AboutDialog().ShowDialog();
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		public Color FavoriteColor
		{
			get
			{
				return colorDialog1.Color;
			}
			set
			{
				colorDialog1.Color = value;
			}
		}

        private void buttonOK_Click(object sender, EventArgs e)
        {
            System.Console.WriteLine("OK");
        }
	}
}
